{	
	// load the shared library with the class definition
	// for Event.
 	gSystem->Load("$ROOTSYS/test/libEvent"); 

 	// Step1
	// create a TFile object, using RECREATE to 
	// overwrite if it exists 	
	TFile *hfile = new TFile("AFile.root",
			"RECREATE","An Example ROOT file");

	// Step 2
	// create a TTree object with the name MyTree, 
	// title : A ROOT tree, and the default buffer size 
	// of 64 MB
	TTree *myTree = new TTree("myTree","A ROOT tree");
	
	// Step 3
	// create an instance of the Event class to use in the branch
	// create a branch to hold the events
	Event *event = new  Event();
	myTree->Branch("EventBranch","Event",&event,64000,99);

	// Step 4
	// write a for loop to assigns values 
	// to create events and 
	// fill the tree with them.
	for (Int_t ev = 0; ev < 10; ev++) {
   	Float_t  sigmat, sigmas;
   	gRandom->Rannor(sigmat,sigmas);
   	Int_t   ntrack   = Int_t (600 + 600*sigmat/120.);
   	Float_t random   = gRandom->Rndm(1); 
   	event ->SetHeader      (ev, 200, 960312, random);
   	event ->SetNseg        (Int_t (6000+20*sigmas));
   	event ->SetNvertex     (1); 
   	event ->SetFlag(UInt_t (random +0.5));
   	event ->SetTemperature (random + 20.);
   	
		for (Int_t t = 0; t < ntrack; t++){
		  event->AddTrack(random);
		} 
   	
		myTree->Fill();   //fill the tree
   	
		event->GetTracks()->Clear();
	}

	// Step 5
	// write the file.
	hfile->Write();
}
	
	
	
	
		
