//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Wed Sep 14 04:31:40 2005 by ROOT version 5.03/01
// from TTree myTree/Example ROOT tree
// found on file: Example.root
//////////////////////////////////////////////////////////

#ifndef formytree_h
#define formytree_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>

class formytree {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain

   // Declaration of leave types
   Float_t         xmain;
   Float_t         xs1;
   Float_t         xs2;

   // List of branches
   TBranch        *b_xmain;   //!
   TBranch        *b_xs1;   //!
   TBranch        *b_xs2;   //!

   formytree(TTree *tree=0);
   virtual ~formytree();
   virtual Int_t    Cut(Long64_t entry);
   virtual Int_t    GetEntry(Long64_t entry);
   virtual Long64_t LoadTree(Long64_t entry);
   virtual void     Init(TTree *tree);
   virtual void     Loop();
   virtual Bool_t   Notify();
   virtual void     Show(Long64_t entry = -1);
};

#endif

#ifdef formytree_cxx
formytree::formytree(TTree *tree)
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   if (tree == 0) {
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("Example.root");
      if (!f) {
         f = new TFile("Example.root");
      }
      tree = (TTree*)gDirectory->Get("myTree");

   }
   Init(tree);
}

formytree::~formytree()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t formytree::GetEntry(Long64_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Long64_t formytree::LoadTree(Long64_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Long64_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (fChain->IsA() != TChain::Class()) return centry;
   TChain *chain = (TChain*)fChain;
   if (chain->GetTreeNumber() != fCurrent) {
      fCurrent = chain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void formytree::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses of the tree
   // will be set. It is normaly not necessary to make changes to the
   // generated code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running with PROOF.

   // Set branch addresses
   if (tree == 0) return;
   fChain = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("xmain",&xmain);
   fChain->SetBranchAddress("xs1",&xs1);
   fChain->SetBranchAddress("xs2",&xs2);
   Notify();
}

Bool_t formytree::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. Typically here the branch pointers
   // will be retrieved. It is normaly not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed.

   // Get branch pointers
   b_xmain = fChain->GetBranch("xmain");
   b_xs1 = fChain->GetBranch("xs1");
   b_xs2 = fChain->GetBranch("xs2");

   return kTRUE;
}

void formytree::Show(Long64_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t formytree::Cut(Long64_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}
#endif // #ifdef formytree_cxx
