//
// Fichier correspondant a la figure de l'exercice du jour 4
//
// on l'execute en tapant dans la ligne de commande:
//      .x exo_J4.C
//
// les informations sur les fonctions accessibles par les differents objets 
// sont disponibles aux URLs suivants:
// TFile         http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TFile.html
// TTree         http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TTree.html
// TH1D          http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TH1D.html
// TH2D          http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TH2D.html
// TPad          http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TPad.html
// TF1           http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TF1.html
// TCutG         http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TCurG.html
// TLatex        http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TLatex.html
// TStyle        http://root.cern.ch/cgi-bin/print_hit_bold.pl/root/html/TStyle.html
//

{
// on veut que les parametres de fit s'affichent dans la boite des statistiques
gStyle->SetOptFit(kTRUE);
// On regarde si le fichier est ouvert
TFile *ft=(TFile *)gROOT->FindObject("r50_69ni.root");
if(!ft)
 {
 ft=new TFile("r50_69ni.root");
 }
// On recupere le pointeur de l'arbre "h1" 
TTree *h1=(TTree *)gROOT->FindObject("h1");

// premiere etape
// Definition du Cut sut les etats de charge
h1->Draw("z:zmqp1");   // on trace le bidim Z vs ZMQP1
// Affichage des etats de charge
TLatex *la=new TLatex(); // creation d'un TLatex pour afficher les etats de
                         // charge sur le bidim
la->SetTextColor(kCyan); // couleur bleu ciel
la->SetTextAlign(22);    // le texte sera centre sur la position indiquee
la->SetTextSize(0.03);   // on ajuste la taille du texte
char *mes=new char[80];  // on cree une chaine de caracteres (avec un pointeur)
for(int i=-1;i<2;i++)
 {
 sprintf(mes,"%d\0",i);  // on ecrit dans la chaine l'etat de charge avec la
                         // routine sprintf(chaine,format,variables) du C.
 la->DrawLatex(i+0.5,27.9,mes); // on la dessine a la position indiquee
 }
gPad->Update();          // on met a jour le TPad courant
// on va regarder si le TCutG "CUTEC" existe
TCutG *cgec=(TCutG *)gROOT->FindObject("CUTEC");
if(!cgec)
 {
 // s'il nexiste pas, on va le creer
 cout << "Definir le contour pout l'etat de charge 0" << endl; // message 
 cgec=(TCutG *)gPad->WaitPrimitive("CUTEC"); // on attend qu'un objet du nom de
 					     // "CUTEC" soit genere sur le TPad
					     // courant. Rien ne se passera tant
					     // que c'est objet n'est pas cree.
					     // c'est la qu'il faut utiliser
					     // l'editeur graphique et renommer
					     // la coupure a CUTEC.	
 cgec->SetTitle(cgec->GetName());  // on met le titre egal au nom
 cgec->SetLineColor(kRed);         // on met la couleur a rouge
 cgec->SetLineWidth(3);            // on met son epaisseur a 3 points
 }
cgec->Draw();   // on dessine la coupure
gPad->Update(); // on remet le TPad courant a jour
cout << "Appuyer sur RETURN." << endl; // on affiche un message
cin.get();    // on attend que la touche RETURN soit pressee

// deuxieme etape
// Definition du Cut sut les isotopes du Ni
h1->Draw("z:aoq");    // on trace le bidim Z vs AOQ
la->SetTextAlign(22); // on centre le texte du TLatex aux coordonnees indiquees 
for(int i=68;i<74;i++) // on bouble sur les isotopes 68 a 73 du Ni
 {
 sprintf(mes,"{}^{%d}Ni\0",i); // on met dans la chaine de caracteres le nom de
 			       // l'isotope avec la fonction sprintf du C
 la->DrawLatex((double)i/28.,27.85+0.05*(1-2*(i%2)),mes); // on dessine le nom
 }
delete [] mes; // on n'a plus besoin de cette chaine de caracteres, on la detruit
delete la;     // idem pour le TLatex
gPad->Update();// on met a jour le TPad courant;
// on va regarder si CUTNI69 et CUTNI70 existent
TCutG *cg69=(TCutG *)gROOT->FindObject("CUTNI69");
TCutG *cg70=(TCutG *)gROOT->FindObject("CUTNI70");
if(!cg69 || !cg70)
 {
 // si CUTNI69 n'existe pas, on le cree avec la meme technique que pour CUTEC
 if(!cg69)
  {
  cout << "Definir le contour pour le Ni 69. " << endl; // message
  cg69=(TCutG *)gPad->WaitPrimitive("CUTNI69"); // on attend qu'il soit cree
  cg69->SetTitle(cg69->GetName()); // on met a jour son titre
  cg69->SetLineColor(kRed); // on passe sa couleur a rouge
  cg69->SetLineWidth(3);    // et son epaisseur a 3 points
  }
 // si CUTNI70 n'existe pas, on le cree avec la meme technique que pour CUTEC
if(!cg70)
  {
  cout << "Definir le contour pour le Ni 70. " << endl; // message
  cg70=(TCutG *)gPad->WaitPrimitive("CUTNI70"); // on attend qu'il soit cree
  cg70->SetTitle(cg70->GetName()); // on met a jour son titre
  cg70->SetLineColor(kBlue);  // on passe sa couleur a bleu
  cg70->SetLineWidth(3);      // et son epaisseur a 3 points
  }
 }
cg69->Draw(); // on dessine CUTNI69
cg70->Draw(); // on dessine CUTNI70
gPad->Update(); // on remet le TPad courant a jour
cout << "Appuyer sur RETURN." << endl; // on affiche un message
cin.get();    // on attend que la touche RETURN soit pressee

// etape 3
// on va determiner les maxima des pics des histogrammes en temps
// les valeurs de ces pics sont rangees dans le tableau tmax ci dessous.
// chaines de caractere permettant d'utiliser un boucle
char commande[80];
char condition[80];
// tableau ou 
double tmax[7];
// histogramme temporaire
TH1F *temps=new TH1F("temps","temps temporaire",256,0,4096);
for(int i=0;i<7;i++)
 {
 sprintf(commande,"tg%dlo >> temps",i+1); // on ecrit la commande dans la chaine
 sprintf(condition,"tg%dlo < 3000",i+1);  // on ecrit la condition
 // on affiche l'ordre qui va etre execute					  
 cout << "h1->Draw(\"" << commande << "\",\"" << condition << "\");" << endl;					   
 h1->Draw(commande,condition); // on excute la commande
 gPad->Update(); // on remet le TPad courant a jour
 // on va rechercher automatiquement le maximum dans l'histogramme 
 // 1. on recupere le numero de canal correspondant au contenu maximum
 int imax=temps->GetMaximumBin();
 // 2. on recupere la valeur de temps qui correpond au numero de canal
 tmax[i]=temps->GetBinCenter(imax);
 // on aurait pu tout taper en une seule ligne:
 // tmax[i]=temps->GetBinCenter(temps->GetMaximumBin());
 cout << i  << " -> " << tmax[i] << endl; // on affiche la valeur trouvee
 cout << "Appuyer sur RETURN." << endl; // on affiche un message
 cin.get();    // on attend que la touche RETURN soit pressee
 }
cout << endl; // on saute une ligne
delete temps; // on detruit l'histogramme temporaire car on ne s'en sert plus



// etape 4
// Fabrication des histogrammes en energie des gammas
TH1D *egtot=new TH1D("egtot","Spectre E #gamma",4086,10,4095);
TH1D *eg69=new TH1D("eg69","Spectre E #gamma {}^{69}Ni",4086,10,4095);
TH1D *eg70=new TH1D("eg70","Spectre E #gamma {}^{70}Ni",4086,10,4095);
// histogrammes Egamma vs temps
TH2D *eg69t=new TH2D("eg69t","Spectre E #gamma vs tdc {}^{69}Ni",64,0,2048,256,10,4095);
TH2D *eg70t=new TH2D("eg70t","Spectre E #gamma vs tdc {}^{70}Ni",64,0,2048,256,10,4095);
// On va maintenant remplir les bidims temps vs Egamma
for(int i=1;i<=7;i++)
 {
 cout << "Variable " << i << endl; // message
 // Ni69
 sprintf(condition,"CUTEC && CUTNI69\0"); // on met la condition dans la chaine
                                          // de caractere
 sprintf(commande,"Eg%dc:(tg%dlo-%f) >>+eg69t\0",i,i,tmax[i-1]); // et la
                                          // commande d'affichage pour le bidim
					  // EGXC vs TGXLO
 // on affiche l'ordre qui va etre execute					  
 cout << "h1->Draw(\"" << commande << "\",\"" << condition << "\");" << endl;					   
 h1->Draw(commande,condition);          // on excute la commande
 
 sprintf(commande,"Eg%dc >>+eg69\0",i); // on change la commande d'affichage
                                        // pour le modim EGXC du NI69
 // on affiche l'ordre qui va etre execute					  
 cout << "h1->Draw(\"" << commande << "\",\"" << condition << "\");" << endl;					   
 h1->Draw(commande,condition);          // on excute la commande 
 
 sprintf(commande,"Eg%dc >>+egtot\0",i);// on change la commande d'affichage
                                        // pour le modim EGXC total
 // on affiche l'ordre qui va etre execute					  
 cout << "h1->Draw(\"" << commande << "\",\"\");" << endl;					   
 h1->Draw(commande,"");
 
 // Ni70
 // on fait la meme chose que pour le NI69 en changeant les conditions
 // et les noms des histogrammes dans les commandes
 sprintf(condition,"CUTEC && CUTNI70\0");
 sprintf(commande,"Eg%dc:(tg%dlo-%f) >>+eg70t\0",i,i,tmax[i-1]);
 cout << "h1->Draw(\"" << commande << "\",\"" << condition << "\");" << endl;					   
 h1->Draw(commande,condition);

 sprintf(commande,"Eg%dc >>+eg70\0",i);
 cout << "h1->Draw(\"" << commande << "\",\"" << condition << "\");" << endl;					   
 h1->Draw(commande,condition);

 sprintf(commande,"Eg%dc >>+egtot\0",i);
 cout << "h1->Draw(\"" << commande << "\",\"\");" << endl;					   
 h1->Draw(commande,"");
 }
 
eg69->SetLineColor(kRed); // on met les pectre gamma du Ni69 a rouge 
eg70->SetLineColor(kBlue);// on met les pectre gamma du Ni70 a bleu
eg70->Draw();      // on affiche eg70
eg69->Draw("same");// et eg69 par dessus
gPad->Update();    // on met a jour le TPad courant
cout << "Appuyer sur RETURN." << endl; // message
cin.get();     // on attend que la touche RETURN soit pressee

//
// On va maintenant fabriquer les spectres de temps cumule pour le Ni70
// pour les 2 pics a 183. et 447. keV. Pour cela, on va projeter les spectres
// 2Dim avec ProjectionX. On va ensuite fitter les spectres associes et extraire
// les temps de decroissance avec la fonction "expo".
//
// on realise la projection pour le pic compris entre 180 et 186 keV
double canal_ymin=eg70t->GetYaxis()->FindBin(180.); // on determine le numero de
                                                    // canal pour la valeur min
						    // de l'energie gamma
double canal_ymax=eg70t->GetYaxis()->FindBin(186.); // on determine le numero de
                                                    // canal pour la valeur max
						    // de l'energie gamma
eg70t->ProjectionX("pic1Ni70",canal_ymin,canal_ymax); // on realise la
                                                      // projection sur X
						      // (temps) entre les
                                                      // canaux indiques. Le nom
						      // de la projection est
						      // "pic1Ni70"

// on refait la meme chone pour le deuxieme pic (entre 444 et  452 keV)
// le nom du spectre projete est "pic2Ni70"
eg70t->ProjectionX("pic2Ni70",eg70t->GetYaxis()->FindBin(444.),
eg70t->GetYaxis()->FindBin(452.));

TH1D *pic1Ni70=(TH1D *)gROOT->FindObject("pic1Ni70"); // on recupere les
TH1D *pic2Ni70=(TH1D *)gROOT->FindObject("pic2Ni70"); // pointeurs des projections

// on va fitter le premier histogramme
// on change le titre 
pic1Ni70->SetTitle("Spectre temps ^{70}Ni, pic E_{#gamma}=183 keV");
pic1Ni70->Fit("expo","","",0.,1200.); // on realise le fit entre 0 et 1200 ns
// on affiche le resultat
cout << "Temps de vie du pic 1: " <<
-log(2.)/pic1Ni70->GetFunction("expo")->GetParameter("Slope") << " ns" << endl;
gPad->Update(); // on met a jour le TPad courant
cout << "Appuyer sur RETURN." << endl; // message
cin.get();     // on attend que la touche RETURN soit pressee

// on va fitter le deuxieme histogramme
// on change le titre 
pic2Ni70->SetTitle("Spectre temps ^{70}Ni, pic E_{#gamma}=447 keV");
pic2Ni70->Fit("expo","","",0.,1200.);
// on affiche le resultat
cout << "Temps de vie du pic 2: " <<
-log(2.)/pic2Ni70->GetFunction("expo")->GetParameter("Slope") << " ns" << endl;

}
