#include <iostream.h>

void tree_struc(void)
{
// Exemple de script qui lit des donnes et remplit un arbre

   //declaration de la structure pour les donnees
   struct Mon_Event{
   	Int_t Mult;
      Float_t Z[50];
   	Float_t Theta[50];
      Float_t Energie[50];
   };
   
   Mon_Event event;
	
   // ouvrir le fichier de donnes pour la lecture
   ifstream file;
   file.open("tree_struc.data");
      
   UInt_t nevents = 100000;
   
   //ouverture d'un fichier pour sauvegarder l'arbre
   TFile *ftree = new TFile("tree_struc.root","recreate");
   
   //declaration de l'arbre
   TTree *t = new TTree("t", "TTree avec une structure");
   
   //declaration des branches pour la structure
   t->Branch("M_part", &event.Mult, "Mult/I");
   t->Branch("Z_part", event.Z, "Z[Mult]/F");
   t->Branch("Th_part", event.Theta, "Theta[Mult]/F");
   t->Branch("E_part", event.Energie, "Energie[Mult]/F");
   
   //boucle sur les evenements
   while( (nevents--) > 0 ){
   	
      //lit la multiplicit de l'vnement
      file >> event.Mult;
      
      //boucle sur les particules de l'evenement
      for(UInt_t i=0; i < event.Mult; i++){
      
      	//lit les proprietes de chaque particule
         file >> event.Z[i];
         file >> event.Theta[i];
         file >> event.Energie[i];
      }
      
      //remplit l'arbre
      t->Fill();
         
      if( !(nevents%1000) ) cout << "Events left = " << nevents << endl;
   }
   
   file.close();
   
   //on ecrit l'arbre dans le fichier ROOT
   t->Write();
   ftree->Close();
   ftree =new TFile("tree_struc.root");
}
